#
###########################################################################################
#
#cd $TRAINING_PATH/NoCddr/support;chmod 777 NoCddr_QemuRun.sh;./NoCddr_QemuRun.sh
# 
# History:
#    2024/05/29 - RS    - 2024.2 - Created this file based on appRun.sh file from FreeRTOS lab 
###########################################################################################
#
##############             Modify below this         ########################
#Only the next two lines need to be modified if using this file for another lab. 
TC_NAME=NoCddr
APP_NAME=qemu_driver_app
# the VITIS_PATH variable points to the installation directory for the current version of Vitis. 
# the following paths are valid for the CustEd VM and CloudShare environments. If you are using
# this on another platform, you will need to modify the following line of code to point to the installation
VITIS_PATH=/opt/amd/Vitis/2024.2
TOOLS=$TRAINING_PATH/tools

##############              No need to modify below this              ########################

# in case this is a new terminal, we need to load the settings64 script
source $VITIS_PATH/settings64.sh
# point to the location of the QEMU binaries
QEMU_ZYNQMP=$VITIS_PATH/data/emulation/qemu/comp/qemu/sysroots/x86_64-petalinux-linux/usr/bin/qemu-system-aarch64
# point to the executable
ELF=$TRAINING_PATH/$TC_NAME/lab/application/$APP_NAME/build/$APP_NAME.elf

#Launching the QEMU with debugger support
$QEMU_ZYNQMP -M arm-generic-fdt -nographic -serial null -serial null -serial mon:stdio -serial null \
-device loader,file=$ELF,cpu-num=0   \
-device loader,addr=0xfd1a0300,data=0x8000000e,data-len=4   -machine-path /tmp/tmp_dir  \
-dtb $TOOLS/versal-qemu-ps.dtb -m 8G -display none \
-gdb tcp::9000  -net nic,netdev=eth0 -netdev user,id=eth0,tftp=/tftpboot -net nic

# run the emulator with the arguments

# DONE

#<copyright-disclaimer-start>
#  **************************************************************************************************************
#  * © 2025 Advanced Micro Devices, Inc. All rights reserved.                                                   *
#  * DISCLAIMER                                                                                                 *
#  * The information contained herein is for informational purposes only, and is subject to change              *
#  * without notice. While every precaution has been taken in the preparation of this document, it              *
#  * may contain technical inaccuracies, omissions and typographical errors, and AMD is under no                *
#  * obligation to update or otherwise correct this information.  Advanced Micro Devices, Inc. makes            *
#  * no representations or warranties with respect to the accuracy or completeness of the contents of           *
#  * this document, and assumes no liability of any kind, including the implied warranties of noninfringement,  *
#  * merchantability or fitness for particular purposes, with respect to the operation or use of AMD            *
#  * hardware, software or other products described herein.  No license, including implied or                   *
#  * arising by estoppel, to any intellectual property rights is granted by this document.  Terms and           *
#  * limitations applicable to the purchase or use of AMD’s products are as set forth in a signed agreement     *
#  * between the parties or in AMD's Standard Terms and Conditions of Sale. GD-18                               *
#  *                                                                                                            *
#  **************************************************************************************************************
#<copyright-disclaimer-end>
